/* ============================= C MeatAxe ==================================
   File:        $Id: c-matrix.c,v 1.1.1.1 2000/01/07 16:42:26 mringe Exp $
   Comment:     Check functions for the word generator.
   --------------------------------------------------------------------------
   (C) Copyright 1998 Michael Ringe, Lehrstuhl D fuer Mathematik,
   RWTH Aachen, Germany  <mringe@math.rwth-aachen.de>
   This program is free software; see the file COPYING for details.
   ========================================================================== */


#include "meataxe.h"
#include "check.h"
#include "c-wgen.h"
#include "c-matrix.h"

#include <stdlib.h>
#include <stdio.h>

/*MTX_DEFINE_FILE_INFO*/


/* --------------------------------------------------------------------------
   TestWgen() - Word generator
   -------------------------------------------------------------------------- */

static void TestWgen1(int fl)
{
}


void TestWgen(unsigned flags)
{
    while (NextField() > 0)
	TestWgen1(FfOrder);
}






/* --------------------------------------------------------------------------
   TestWgMap() 
   -------------------------------------------------------------------------- */

static void TestWgMap1(WgData_t *wg, Matrix_t *unit)
{
    const int word[] = {0,1,2,3,33,47,999,228172};
    int i;
    for (i = 0; i < sizeof(word)/sizeof(word[0]); ++i)
    {
	Matrix_t *result1 = WgMap(wg,word[i],unit);
	Matrix_t *w = WgMakeWord(wg,word[i]);
	Matrix_t *result2 = MatDup(unit);
	MatMul(result2,w);
	if (MatCompare(result1,result2))
	{
	    MatPrint("input",unit);
	    MatPrint("word",w);
	    MatPrint("result1",result1);
	    MatPrint("result2",result2);
	    Error("WgMap() and WgMakeWord() produce different results (word %d)",word[i]);
	}
	MatFree(result2);
	MatFree(result1);
	MatFree(w);
    }
}


void TestWgMap(unsigned flags)
{
    const int noc = 30;
    MtxRandomInit(11);
    while (NextField() > 0)
    {
	Matrix_t *unit;
	WgData_t *wg;
	Rep_t *rep;
	rep = RepAlloc(0,NULL);
	RepAddGenerator(rep,(MtxObject_t*)RndMat(FfOrder,noc,noc));
	RepAddGenerator(rep,(MtxObject_t*)RndMat(FfOrder,noc,noc));
	RepAddGenerator(rep,(MtxObject_t*)RndMat(FfOrder,noc,noc));
	unit = MatId(FfOrder,noc);
	wg = WgAlloc(rep);
	TestWgMap1(wg,unit);
	WgFree(wg);
	MatFree(unit);
	RepFree(rep);
    }
}





